commit 3ca9a9aeead51a0981085405f3c1f540e8d992ba
Author: Florian Weimer <fweimer@redhat.com>
Date:   Thu Apr 5 12:50:58 2018 +0200

    manual: Move mbstouwcs to an example C file
    
    (cherry picked from commit 0f339252697e6dcfc9e00be6cd8272d4260b90d2)

diff --git a/ChangeLog b/ChangeLog
index bbf9af1fb8..ef2816a098 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+2018-04-05  Florian Weimer  <fweimer@redhat.com>
+
+	* manual/examples/mbstouwcs.c: New file.
+	* manual/charset.texi (Converting a Character): Include it.
+
 2018-04-03  H.J. Lu  <hongjiu.lu@intel.com>
 
 	[BZ #22947]
diff --git a/manual/examples/mbstouwcs.c b/manual/examples/mbstouwcs.c
new file mode 100644
index 0000000000..5d223da2ae
--- /dev/null
+++ b/manual/examples/mbstouwcs.c
@@ -0,0 +1,28 @@
+#include <stdlib.h>
+#include <string.h>
+#include <wchar.h>
+
+/* Do not include the above headers in the example.
+*/
+wchar_t *
+mbstouwcs (const char *s)
+{
+  size_t len = strlen (s);
+  wchar_t *result = malloc ((len + 1) * sizeof (wchar_t));
+  wchar_t *wcp = result;
+  wchar_t tmp[1];
+  mbstate_t state;
+  size_t nbytes;
+
+  memset (&state, '\0', sizeof (state));
+  while ((nbytes = mbrtowc (tmp, s, len, &state)) > 0)
+    {
+      if (nbytes >= (size_t) -2)
+        /* Invalid input string.  */
+        return NULL;
+      *wcp++ = towupper (tmp[0]);
+      len -= nbytes;
+      s += nbytes;
+    }
+  return result;
+}

